/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements. See the NOTICE file distributed with this
 * work for additional information regarding copyright ownership. The ASF
 * licenses this file to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.apache.flume.conf.configfilter;

import org.apache.flume.conf.ComponentWithClassName;

public enum ConfigFilterType implements ComponentWithClassName {
  OTHER(null),
  ENV("org.apache.flume.configfilter.EnvironmentVariableConfigFilter"),
  HADOOP("org.apache.flume.configfilter.HadoopCredentialStoreConfigFilter"),
  EXTERNAL("org.apache.flume.configfilter.ExternalProcessConfigFilter");

  private final String className;

  ConfigFilterType(String className) {
    this.className = className;
  }

  @Override
  public String getClassName() {
    return className;
  }
}
